// ====================================================================
// Yann COLLETTE
// Copyright 2009-2012
// This file is released into the public domain
// ====================================================================

ampl_path = get_absolute_file_path('builder_gateway_c.sce');

Build_Dev = %f;

list_add_inter      = ['ampl_free',            'sci_ampl_free'; ...
                       'ampl_init',            'sci_ampl_init'; ...
                       'ampl_evalf',           'sci_ampl_evalf'; ...
                       'ampl_evalg',           'sci_ampl_evalg'; ...
                       'ampl_eval_sp_g',       'sci_ampl_eval_sp_g'; ...
                       'ampl_eval_spst_g_rc',  'sci_ampl_eval_spst_g_rc'; ...
                       'ampl_eval_spst_g_val', 'sci_ampl_eval_spst_g_val'; ...
                       'ampl_evalw',           'sci_ampl_evalw'; ...
                       'ampl_eval_sp_w',       'sci_ampl_eval_sp_w'; ...
                       'ampl_write_sol',       'sci_ampl_write_sol'; ...
                       'ampl_get_compl',       'sci_ampl_get_compl'; ...
                       'ampl_get_type',        'sci_ampl_get_type'; ...
                       'ampl_get_size',        'sci_ampl_get_size'];

if Build_Dev then
    list_add_inter = [list_add_inter; ...
                      'ampl_get_dag', 'sci_ampl_get_dag'];
end

files_to_compile    = ['sci_ampl.c'];

libs = ['../../src/c/libjac0dim_ASL'];

if getos()=='Windows' then
  //windows_sdk_lib     = '""c:/Program Files/Microsoft Platform SDK for Windows Server 2003 R2/Lib/AMD64/uuid.lib""';
  //windows_sdk_lib     = '';
  //link_options        = '/NODEFAULTLIB:LIBCMT'; // /NODEFAULTLIB:MSVCPRT /NODEFAULTLIB:MSVCRT 
  //windows_sdk_include = '""C:/Program Files/Microsoft Platform SDK for Windows Server 2003 R2/Include""';
  //windows_sdk_include = '""H:/Program Files/Microsoft SDKs/Windows/v6.1/Include""';
  //cflags              = '/MTd /EHs /I . /I ../../src/c /I /D__USE_DEPRECATED_STACK_FUNCTIONS__ ' + windows_sdk_include;

  cflags              = '-I. -I../../src/c -D__USE_DEPRECATED_STACK_FUNCTIONS__ -D_WIN32 -DWIN32)';
  //ldflags             = windows_sdk_lib + ' ' + link_options + ' ../../src/c/amplsolv.lib';
  ldflags             = '';
else
  cflags              = '-Wall -ggdb -D__USE_DEPRECATED_STACK_FUNCTIONS__ -I' + ampl_path + '../../src/c -I' + ampl_path + ' -I../../src/c';
  ldflags             = '';
end

if Build_Dev then
  cflags = cflags + ' -DAMPL_SCI_DEV';
end

tbx_build_gateway('ampl_c', list_add_inter, files_to_compile, get_absolute_file_path('builder_gateway_c.sce'), libs, ldflags, cflags);

clear tbx_build_gateway;
